'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

var _reactVirtualized = require('react-virtualized');

var _immutable = require('immutable');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // @TODO
// hot keys: select option on Enter, remove on Backspcae, highlight etc
// disable option

var DEFAULT_LIST_POSITION = 'bottom';

var ReactSelectMe = function (_Component) {
  _inherits(ReactSelectMe, _Component);

  function ReactSelectMe(props) {
    _classCallCheck(this, ReactSelectMe);

    var _this = _possibleConstructorReturn(this, (ReactSelectMe.__proto__ || Object.getPrototypeOf(ReactSelectMe)).call(this, props));

    _this.state = {
      opened: props.isOpened === undefined ? false : props.isOpened,
      search: ''
    };

    _this.ssr = typeof window === 'undefined';

    _this.closeGlobal = _this.closeGlobal.bind(_this);
    _this.skipEventPropagation = _this.skipEventPropagation.bind(_this);
    _this.toImmutable = _this.toImmutable.bind(_this);
    _this.patchSelectedOption = _this.patchSelectedOption.bind(_this);
    _this.getOptions = _this.getOptions.bind(_this);
    _this.getOptionHeight = _this.getOptionHeight.bind(_this);
    _this.getSelectedOptions = _this.getSelectedOptions.bind(_this);
    _this.getListProps = _this.getListProps.bind(_this);
    _this.getOffset = _this.getOffset.bind(_this);
    _this.getCount = _this.getCount.bind(_this);
    _this.getSearchString = _this.getSearchString.bind(_this);
    _this.renderList = _this.renderList.bind(_this);
    _this.renderOption = _this.renderOption.bind(_this);
    _this.renderIcon = _this.renderIcon.bind(_this);
    _this.renderSelectedBlock = _this.renderSelectedBlock.bind(_this);
    _this.renderSearchInput = _this.renderSearchInput.bind(_this);
    _this.renderSelectedItem = _this.renderSelectedItem.bind(_this);
    _this.renderAddNewItem = _this.renderAddNewItem.bind(_this);
    _this.renderNoItemsFound = _this.renderNoItemsFound.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.onRemoveSelected = _this.onRemoveSelected.bind(_this);
    _this.onToggle = _this.onToggle.bind(_this);
    _this.onSearch = _this.onSearch.bind(_this);
    _this.onAddNewItem = _this.onAddNewItem.bind(_this);
    _this.onOpen = _this.onOpen.bind(_this);
    _this.onClose = _this.onClose.bind(_this);
    return _this;
  }

  /* ***************************************
  ************ Lifecycle events ************
  *****************************************/


  _createClass(ReactSelectMe, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('click', this.closeGlobal);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.isOpened !== undefined && this.state.opened !== nextProps.isOpened) {
        this.setState({
          opened: nextProps.isOpened
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _reactAddonsShallowCompare2.default)(this, nextProps, nextState);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.closeGlobal);
    }

    /* ***************************************
    **************** Utils *******************
    *****************************************/

  }, {
    key: 'warn',
    value: function warn(msg) {
      if (process.env.NODE_ENV !== 'production') {
        console.warn(msg); // eslint-disable-line no-console
      }
    }
  }, {
    key: 'closeGlobal',
    value: function closeGlobal(e) {
      var _props = this.props;
      var isOpened = _props.isOpened;
      var beforeClose = _props.beforeClose;
      // @maslianok: when you decide to change this, please, keep in mind, that this case should work:
      // Open A -> Open B -> A should be closed

      if (this.skipPropagation || !this.state.opened) {
        this.skipPropagation = undefined;
        return;
      }

      if (!isOpened && beforeClose(e) !== false) {
        this.setState({ opened: false }, this.onClose);
      }
    }
  }, {
    key: 'skipEventPropagation',
    value: function skipEventPropagation() {
      this.skipPropagation = true;
    }
  }, {
    key: 'toImmutable',
    value: function toImmutable(data) {
      var immutable = this.props.immutable;

      return immutable ? (0, _immutable.fromJS)(data) : data;
    }
  }, {
    key: 'patchSelectedOption',
    value: function patchSelectedOption(selectedOption, options) {
      var _this2 = this,
          _toImmutable;

      var _props2 = this.props;
      var valueKey = _props2.valueKey;
      var labelKey = _props2.labelKey;
      // if object

      if ((typeof selectedOption === 'undefined' ? 'undefined' : _typeof(selectedOption)) === 'object') {
        // just return this value
        return selectedOption;
      }

      // if primitive (Number or String)

      // search for this option in `options` array
      var option = options.find(function (o) {
        return _this2.getProp(o, valueKey) === selectedOption;
      });
      if (option) {
        return option;
      }

      // if not found - map it to object
      return this.toImmutable((_toImmutable = {}, _defineProperty(_toImmutable, valueKey, selectedOption), _defineProperty(_toImmutable, labelKey, selectedOption), _toImmutable));
    }
    /* ***************************************
    ************** Renderers *****************
    *****************************************/

  }, {
    key: 'renderList',
    value: function renderList() {
      var _cs,
          _this3 = this;

      var _props3 = this.props;
      var addNewItem = _props3.addNewItem;
      var searchable = _props3.searchable;
      var listRenderer = _props3.listRenderer;
      var virtualized = _props3.virtualized;
      var s = _props3.s;


      if (!this.state.opened) {
        return undefined;
      }

      var options = this.getOptions();
      var selectedOptions = this.getSelectedOptions();

      if (typeof listRenderer === 'function') {
        return listRenderer(options, selectedOptions, this.renderOption, this.onChange, this.onToggle);
      }

      var _getListProps = this.getListProps();

      var direction = _getListProps.direction;
      var calculatedListHeight = _getListProps.calculatedListHeight;

      var listClasses = (0, _classnames2.default)('dd__list', s.dd__list, 'dd__openTo' + direction, s['dd__openTo' + direction], (_cs = {}, _defineProperty(_cs, s.dd__listVirtualized, virtualized), _defineProperty(_cs, 'dd__listVirtualized', virtualized), _cs));

      var rowCount = this.getCount(options);
      if (rowCount && virtualized) {
        var _ret = function () {
          var rowClassName = (0, _classnames2.default)('dd__optionVirtualized', s.dd__optionVirtualized);
          return {
            v: _react2.default.createElement(
              _reactVirtualized.AutoSizer,
              { disableHeight: true },
              function (_ref) {
                var width = _ref.width;
                return _react2.default.createElement(_reactVirtualized.List, {
                  width: width,
                  height: calculatedListHeight,
                  rowHeight: _this3.getOptionHeight,
                  rowCount: rowCount,
                  className: listClasses,
                  rowClassName: rowClassName,
                  rowRenderer: function rowRenderer(_ref2) {
                    var style = _ref2.style;
                    var index = _ref2.index;
                    return _this3.renderOption(_this3.getProp(options, index), selectedOptions, style);
                  }
                });
              }
            )
          };
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }

      var listContent = void 0;
      if (rowCount) {
        listContent = options.map(function (option) {
          return _this3.renderOption(option, selectedOptions);
        });
      } else {
        listContent = addNewItem && searchable && this.getSearchString() ? this.renderAddNewItem() : this.renderNoItemsFound();
      }

      return _react2.default.createElement(
        'div',
        { className: listClasses, style: { maxHeight: calculatedListHeight + 'px' } },
        listContent
      );
    }
  }, {
    key: 'renderOption',
    value: function renderOption(option, selectedOptions, style) {
      var _this4 = this;

      var _props4 = this.props;
      var valueKey = _props4.valueKey;
      var labelKey = _props4.labelKey;
      var optionRenderer = _props4.optionRenderer;
      var s = _props4.s;

      var isSelected = selectedOptions.some(function (selected) {
        return _this4.getProp(selected, valueKey) === _this4.getProp(option, valueKey);
      });
      var className = (0, _classnames2.default)('dd__option', s.dd__option, _defineProperty({
        dd__selectedOption: isSelected
      }, s.dd__selectedOption, isSelected));

      var label = typeof optionRenderer === 'function' ? optionRenderer(option, selectedOptions) : _react2.default.createElement(
        'div',
        { className: className },
        this.getProp(option, labelKey)
      );

      return _react2.default.createElement(
        'div',
        { key: this.getProp(option, valueKey), style: style, onClick: this.onChange(option) },
        label
      );
    }
  }, {
    key: 'renderSelectedBlock',
    value: function renderSelectedBlock() {
      var _this5 = this;

      var _props5 = this.props;
      var placeholder = _props5.placeholder;
      var searchable = _props5.searchable;
      var multiple = _props5.multiple;
      var s = _props5.s;
      var selectedValueRenderer = _props5.selectedValueRenderer;
      var selectedBlockRenderer = _props5.selectedBlockRenderer;
      var opened = this.state.opened;

      var valueRenderer = selectedValueRenderer || this.renderSelectedItem;
      var selectedOptions = this.getSelectedOptions();

      if (selectedBlockRenderer) {
        return selectedBlockRenderer(selectedOptions, this.onChange, valueRenderer, this.renderSearchInput);
      }

      var selectedBlockClasses = (0, _classnames2.default)('dd__selected', s.dd__selected);
      var placeholderClasses = (0, _classnames2.default)('dd__placeholder', s.dd__placeholder);
      var noOptionsSelected = !this.getCount(selectedOptions);

      var selectedElements = void 0;
      if (!noOptionsSelected && (multiple || !searchable || !opened)) {
        selectedElements = selectedOptions.map(function (option) {
          return valueRenderer(option, _this5.onChange);
        });
      }

      return _react2.default.createElement(
        'div',
        { className: selectedBlockClasses },
        selectedElements,
        noOptionsSelected && (!searchable || !opened) && _react2.default.createElement(
          'div',
          { className: placeholderClasses },
          placeholder
        ),
        searchable && this.renderSearchInput()
      );
    }
  }, {
    key: 'renderSearchInput',
    value: function renderSearchInput() {
      var _this6 = this;

      var _props6 = this.props;
      var s = _props6.s;
      var searchInputRenderer = _props6.searchInputRenderer;

      var selectedOptions = this.getSelectedOptions();
      var className = (0, _classnames2.default)('dd__search', s.dd__search);

      if (typeof searchInputRenderer === 'function') {
        return searchInputRenderer(selectedOptions, this.onSearch);
      }

      return _react2.default.createElement('div', {
        contentEditable: true,
        tabIndex: 0,
        className: className,
        onInput: this.onSearch,
        onKeyDown: this.onSearch,
        onFocus: this.onSearch,
        onClick: this.onSearch,
        onPaste: this.onSearch,
        ref: function ref(e) {
          return _this6.searchInput = e;
        }
      });
    }
  }, {
    key: 'renderSelectedItem',
    value: function renderSelectedItem(option) {
      var _props7 = this.props;
      var valueKey = _props7.valueKey;
      var labelKey = _props7.labelKey;
      var multiple = _props7.multiple;
      var s = _props7.s;

      var selectedOptionClasses = (0, _classnames2.default)('dd__selectedItem', s.dd__selectedItem);
      var crossIconClasses = (0, _classnames2.default)('dd__crossIcon', s.dd__crossIcon);

      return _react2.default.createElement(
        'div',
        { className: selectedOptionClasses, key: this.getProp(option, valueKey) },
        _react2.default.createElement(
          'div',
          null,
          this.getProp(option, labelKey)
        ),
        multiple && _react2.default.createElement(
          'div',
          { className: crossIconClasses, onClick: this.onRemoveSelected(option) },
          '×'
        )
      );
    }
  }, {
    key: 'renderIcon',
    value: function renderIcon() {
      var _props8 = this.props;
      var iconRenderer = _props8.iconRenderer;
      var s = _props8.s;
      var opened = this.state.opened;

      if (typeof iconRenderer === 'function') {
        return iconRenderer(opened);
      }

      var className = (0, _classnames2.default)('dd__expandIcon', s.dd__expandIcon);
      var path = 'M315,1318.04l-4.5,4.96-4.5-4.96,0.944-1.04,3.557,3.92,3.553-3.92,0.944,1.04m-9-5.08,4.5-4.96,4.5,4.96-0.944,1.04-3.557-3.92-3.553,3.92L306,1312.96'; // eslint-disable-line max-len
      return _react2.default.createElement(
        'svg',
        { className: className, viewBox: '0 0 9 15', width: '9px', height: '15px' },
        _react2.default.createElement('path', { d: path, transform: 'translate(-306 -1308)' })
      );
      /* eslint-enable */
    }
  }, {
    key: 'renderAddNewItem',
    value: function renderAddNewItem() {
      var _props9 = this.props;
      var s = _props9.s;
      var addNewItem = _props9.addNewItem;

      var classNames = (0, _classnames2.default)('dd__option', s.dd__option);

      if (addNewItem === false) {
        return null;
      }

      var search = this.getSearchString();
      if (typeof addNewItem === 'function') {
        return addNewItem(search);
      }

      return _react2.default.createElement(
        'div',
        { className: classNames, onClick: this.onAddNewItem },
        typeof addNewItem === 'undefined' || addNewItem === true ? 'Add \'' + search + '\'' : addNewItem
      );
    }
  }, {
    key: 'renderNoItemsFound',
    value: function renderNoItemsFound() {
      var _props10 = this.props;
      var s = _props10.s;
      var noItemsFound = _props10.noItemsFound;

      var classNames = (0, _classnames2.default)('dd__option', 'dd__optionDisabled', s.dd__option, s.dd__optionDisabled);

      if (noItemsFound === false) {
        return null;
      }

      if (typeof noItemsFound === 'function') {
        return noItemsFound();
      }

      return _react2.default.createElement(
        'div',
        { className: classNames },
        typeof noItemsFound === 'undefined' || noItemsFound === true ? 'No items found' : noItemsFound
      );
    }
    /* ***************************************
    *************** Getters ******************
    *****************************************/

  }, {
    key: 'getProp',
    value: function getProp(option, key) {
      var immutable = this.props.immutable;

      return immutable ? option.get(key) : option[key];
    }
  }, {
    key: 'getCount',
    value: function getCount(items) {
      var immutable = this.props.immutable;

      if (!items) {
        return false;
      }
      return immutable ? items.size : items.length;
    }
  }, {
    key: 'getOptions',
    value: function getOptions() {
      var _this7 = this;

      var _props11 = this.props;
      var options = _props11.options;
      var labelKey = _props11.labelKey;
      var valueKey = _props11.valueKey;

      if (this.getCount(options)) {
        // options are objects
        if (_typeof(this.getProp(options, 0)) === 'object') {
          return options;
        }

        // options are strings or numbers
        return options.map(function (option) {
          var _this7$toImmutable;

          return _this7.toImmutable((_this7$toImmutable = {}, _defineProperty(_this7$toImmutable, labelKey, option), _defineProperty(_this7$toImmutable, valueKey, option), _this7$toImmutable));
        });
      }

      // no options
      return this.toImmutable([]);
    }
  }, {
    key: 'getSelectedOptions',
    value: function getSelectedOptions() {
      var _this8 = this;

      var _props12 = this.props;
      var value = _props12.value;
      var multiple = _props12.multiple;

      var options = this.getOptions();

      if (!value || multiple && !this.getCount(value)) {
        return this.toImmutable([]);
      }

      return multiple ? value.map(function (v) {
        return _this8.patchSelectedOption(v, options);
      }) : this.toImmutable([this.patchSelectedOption(value, options)]);
    }
  }, {
    key: 'getListProps',
    value: function getListProps() {
      var _props13 = this.props;
      var listHeight = _props13.listHeight;
      var listMaxHeight = _props13.listMaxHeight;
      var listPosition = _props13.listPosition;
      var boundaryMargin = _props13.boundaryMargin;
      var options = _props13.options;

      var direction = void 0;

      if (this.ssr) {
        return {
          direction: DEFAULT_LIST_POSITION,
          calculatedListHeight: listHeight || listMaxHeight
        };
      }

      var refinedHeight = 0;
      if (listHeight) {
        refinedHeight = listHeight;
      } else {
        var optionsCount = this.getCount(options);
        if (optionsCount) {
          for (var i = 0; i < optionsCount; i += 1) {
            if (refinedHeight >= listMaxHeight) {
              refinedHeight = listMaxHeight;
              break;
            }
            refinedHeight += this.getOptionHeight({ index: i });
          }
        } else {
          refinedHeight = this.getOptionHeight({ index: -1 });
        }
      }

      var _getOffset = this.getOffset();

      var top = _getOffset.top;
      var bottom = _getOffset.bottom;

      if (listPosition === 'auto') {
        direction = bottom < refinedHeight + boundaryMargin && top > bottom ? 'top' : 'bottom';
      } else {
        direction = listPosition;
      }

      var calculatedListHeight = void 0;
      if (listHeight) {
        calculatedListHeight = listHeight;
      } else {
        var maxAvailableHeight = (direction === 'top' ? top : bottom) - boundaryMargin;
        calculatedListHeight = Math.min(maxAvailableHeight, refinedHeight);
      }

      return {
        direction: direction,
        calculatedListHeight: calculatedListHeight
      };
    }
  }, {
    key: 'getOffset',
    value: function getOffset() {
      if (this.ssr || !this.el) {
        return { top: 0, bottom: 0 };
      }

      var getWrapper = this.props.getWrapper;

      var wrapper = getWrapper();
      var rectEl = this.el.getBoundingClientRect();
      if (wrapper) {
        // calculate offsets based on wrapper position
        var rectWrapper = wrapper.getBoundingClientRect();
        return {
          top: rectEl.top - rectWrapper.top,
          bottom: rectWrapper.bottom - rectEl.bottom
        };
      }

      // calculate offsets based on viewport
      var viewportHeight = window.document.documentElement.clientHeight;
      return { top: rectEl.top, bottom: viewportHeight - rectEl.bottom };
    }
  }, {
    key: 'getOptionHeight',
    value: function getOptionHeight(_ref3) {
      var index = _ref3.index;
      var _props14 = this.props;
      var optionHeight = _props14.optionHeight;
      var options = _props14.options;

      return typeof optionHeight === 'function' ? optionHeight(this.getProp(options, index)) : optionHeight;
    }
  }, {
    key: 'getSearchString',
    value: function getSearchString() {
      return (this.searchInput.textContent || this.searchInput.innerText || '').replace(/\n/g, '');
    }
    /* ***************************************
    **************** Events ******************
    *****************************************/

  }, {
    key: 'onChange',
    value: function onChange(option, removeFromSelectedBlock) {
      var _this9 = this;

      return function () {
        var _props15 = _this9.props;
        var multiple = _props15.multiple;
        var immutable = _props15.immutable;
        var onChange = _props15.onChange;
        var valueKey = _props15.valueKey;

        var selectedValue = void 0;

        if (multiple) {
          (function () {
            // prepare values for multiselect
            var values = _this9.getSelectedOptions();
            var selectedIndex = values.findIndex(function (v) {
              return _this9.getProp(v, valueKey) === _this9.getProp(option, valueKey);
            });
            if (selectedIndex === -1) {
              // add new option to selected values
              selectedValue = immutable ? values.push(option) : [].concat(_toConsumableArray(values), [option]);
            } else {
              // remove option from selected values
              selectedValue = values.filter(function (v, i) {
                return i !== selectedIndex;
              });
            }
          })();
        } else {
          selectedValue = option;
        }

        if (onChange(selectedValue, removeFromSelectedBlock) === false) {
          _this9.skipEventPropagation();
        }
      };
    }
  }, {
    key: 'onRemoveSelected',
    value: function onRemoveSelected(option) {
      var _this10 = this;

      return function (e) {
        _this10.skipEventPropagation();
        _this10.onChange(option, true)(e);
      };
    }
  }, {
    key: 'onToggle',
    value: function onToggle(e) {
      if (this.skipPropagation) {
        return;
      }

      var _props16 = this.props;
      var searchable = _props16.searchable;
      var beforeOpen = _props16.beforeOpen;
      var beforeClose = _props16.beforeClose;
      var isOpened = _props16.isOpened;
      var disabled = _props16.disabled;
      var opened = this.state.opened;


      var nextState = isOpened !== undefined ? isOpened : !opened;
      var beforeFunc = nextState ? beforeOpen : beforeClose;

      if (!disabled && nextState !== opened && beforeFunc(e) !== false) {
        var afterFunc = nextState ? this.onOpen : this.onClose;
        this.skipEventPropagation();
        if (searchable && this.searchInput) {
          if (nextState) {
            this.searchInput.focus();
          } else {
            this.searchInput.blur();
            window.getSelection().removeAllRanges();
          }
        }
        this.setState({ opened: nextState }, afterFunc);
      }
    }
  }, {
    key: 'onSearch',
    value: function onSearch(evt) {
      var _this11 = this;

      if (!this.searchInput) {
        return;
      }

      var doSearch = function doSearch() {
        var search = _this11.getSearchString();
        if (search !== _this11.prevSearch) {
          _this11.setState({ search: search });

          var onSearch = _this11.props.onSearch;

          if (typeof onSearch === 'function') {
            onSearch(search);
          }
        }
        _this11.prevSearch = search;
      };

      if (!this.skipPropagation) {
        var opened = this.state.opened;

        switch (evt.type) {
          case 'paste':
            // strip html tags
            evt.preventDefault();

            // Get pasted data via clipboard API
            var clipboardData = evt.clipboardData || window.clipboardData;
            var newContent = this.searchInput.textContent + clipboardData.getData('Text');

            // set new content
            this.searchInput.textContent = newContent;

            // place cursor to the end
            var range = document.createRange();
            range.selectNodeContents(this.searchInput);
            range.collapse(false);
            var selection = window.getSelection();
            selection.removeAllRanges();
            selection.addRange(range);

            // trigger search
            doSearch();
            break;
          case 'focus':
            // open dropdown onFocus
            if (!opened) {
              this.onToggle(evt);
              this.skipPropagation = undefined;
            }
            break;
          case 'click':
            // do not close dropdown onClick
            if (opened) {
              this.skipEventPropagation();
            }
            break;
          case 'keydown':
            if (evt.nativeEvent.keyCode === 9 && opened) {
              // close dropdown on Tab keydown
              // blur via Tab
              this.onToggle(evt);
              this.skipPropagation = undefined;
            } else if (evt.nativeEvent.keyCode === 13) {
              // restrict new line
              evt.preventDefault();
            }
            break;
          case 'input':
            doSearch();
            break;
          default:
            break;
        }
      }
    }
  }, {
    key: 'onAddNewItem',
    value: function onAddNewItem() {
      var onAddNewItem = this.props.onAddNewItem;

      if (typeof onAddNewItem === 'function') {
        onAddNewItem(this.getSearchString(), this.getSelectedOptions());
      }
    }
  }, {
    key: 'onOpen',
    value: function onOpen() {
      var onOpen = this.props.onOpen;

      if (typeof onOpen === 'function') {
        onOpen();
      }
    }
  }, {
    key: 'onClose',
    value: function onClose() {
      var _props17 = this.props;
      var onClose = _props17.onClose;
      var clearFilterOnClose = _props17.clearFilterOnClose;
      var onSearch = _props17.onSearch;
      var search = this.state.search;


      if (clearFilterOnClose && search) {
        this.setState({
          search: ''
        });

        if (this.searchInput) {
          this.prevSearch = undefined;
          this.searchInput.innerHTML = '';
        }

        if (typeof onSearch === 'function') {
          onSearch('');
        }
      }

      if (typeof onClose === 'function') {
        onClose();
      }
    }
    /* ***************************************
    **************** Render ******************
    *****************************************/

  }, {
    key: 'render',
    value: function render() {
      var _cs3,
          _this12 = this;

      var _props18 = this.props;
      var error = _props18.error;
      var multiple = _props18.multiple;
      var disabled = _props18.disabled;
      var s = _props18.s;
      var opened = this.state.opened;

      // classnames

      var wrapperClassnames = (0, _classnames2.default)('dd__wrapper', s.dd__wrapper, (_cs3 = {
        dd__opened: opened,
        dd__error: error,
        dd__multi: multiple,
        dd__disabled: disabled
      }, _defineProperty(_cs3, s.dd__opened, opened), _defineProperty(_cs3, s.dd__error, error), _defineProperty(_cs3, s.dd__multi, multiple), _defineProperty(_cs3, s.dd__disabled, disabled), _cs3));
      var selectControlClasses = (0, _classnames2.default)('dd__selectControl', s.dd__selectControl);
      var toggleHandler = this.onToggle;

      return _react2.default.createElement(
        'div',
        { className: wrapperClassnames },
        _react2.default.createElement(
          'div',
          { className: selectControlClasses, onClick: toggleHandler, ref: function ref(el) {
              return _this12.el = el;
            } },
          this.renderSelectedBlock(),
          this.renderIcon()
        ),
        this.renderList()
      );
    }
  }]);

  return ReactSelectMe;
}(_react.Component);

exports.default = ReactSelectMe;


ReactSelectMe.defaultProps = {
  addNewItem: false,
  beforeClose: function beforeClose() {
    return true;
  },
  beforeOpen: function beforeOpen() {
    return true;
  },
  boundaryMargin: 8,
  clearFilterOnClose: true,
  getWrapper: function getWrapper() {
    return null;
  },
  onAddNewItem: function onAddNewItem() {
    return null;
  },
  onClose: function onClose() {
    return null;
  },
  onChange: function onChange() {
    return null;
  },
  onOpen: function onOpen() {
    return null;
  },
  optionHeight: 40,
  options: [],
  labelKey: 'label',
  listMaxHeight: 400,
  listPosition: 'auto',
  noItemsFound: true,
  placeholder: 'Select ...',
  valueKey: 'value',
  s: {}
};

var classType = _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.array]);
ReactSelectMe.propTypes = {
  addNewItem: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.string, _react.PropTypes.func, _react.PropTypes.element]),
  beforeClose: _react.PropTypes.func,
  beforeOpen: _react.PropTypes.func,
  boundaryMargin: _react.PropTypes.number,
  clearFilterOnClose: _react.PropTypes.bool,
  disabled: _react.PropTypes.bool,
  error: _react.PropTypes.bool,
  getWrapper: _react.PropTypes.func,
  iconRenderer: _react.PropTypes.func,
  immutable: _react.PropTypes.bool,
  isOpened: _react.PropTypes.bool,
  labelKey: _react.PropTypes.string,
  listHeight: _react.PropTypes.number,
  listMaxHeight: _react.PropTypes.number,
  listPosition: _react.PropTypes.oneOf(['top', 'bottom', 'auto']),
  listRenderer: _react.PropTypes.func,
  multiple: _react.PropTypes.bool,
  noItemsFound: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.string, _react.PropTypes.func, _react.PropTypes.element]),
  onAddNewItem: _react.PropTypes.func,
  onChange: _react.PropTypes.func.isRequired,
  onClose: _react.PropTypes.func,
  onOpen: _react.PropTypes.func,
  onSearch: _react.PropTypes.func,
  optionRenderer: _react.PropTypes.func,
  options: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object]),
  placeholder: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.element]),
  optionHeight: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.func]),
  /* eslint-disable react/no-unused-prop-types */
  s: _react.PropTypes.shape({
    // wrapper
    dd__wrapper: classType,
    // applied to multi select
    dd__multi: classType,
    // applied to single select
    dd__single: classType,
    // applied when dropdown opened
    dd__opened: classType,
    // applied when dropdown has error property
    dd__error: classType,
    // disabled
    dd_disabled: classType,
    // selected block class
    dd__selectControl: classType,
    // selected values wrapper class
    dd__selected: classType,
    // placeholder class
    dd__placeholder: classType,
    // selected option class
    dd__selectedItem: classType,
    // icon to remove selected value class
    dd__crossIcon: classType,
    // list class
    dd__list: classType,
    // virtualized list class
    dd__listVirtualized: classType,
    // applied when select opens to bottom
    dd__openTobottom: classType,
    // applied when select opens to top
    dd__openTotop: classType,
    // dropdown option
    dd__option: classType,
    // dropdown option
    dd__optionDisabled: classType,
    // virtualized option class
    dd__optionVirtualized: classType,
    // selected dropdown option
    dd__selectedOption: classType
  }),
  /* eslint-enable react/no-unused-prop-types */
  searchable: _react.PropTypes.bool,
  searchInputRenderer: _react.PropTypes.func,
  selectedBlockRenderer: _react.PropTypes.func,
  selectedValueRenderer: _react.PropTypes.func,
  value: _react.PropTypes.any,
  valueKey: _react.PropTypes.string,
  virtualized: _react.PropTypes.bool
};